import { Injectable } from '@nestjs/common';

@Injectable()
export class AppService {
  getAppInfo() {
    return {
      title: 'Real-time Chat API',
      description: 'Real-time chat API with media support, WebSocket, DM, group chats, E2E encryption, and push notifications',
      version: '1.0.0',
      documentation: '/docs',
      health: '/health',
    };
  }

  getHealthStatus() {
    return {
      status: 'healthy',
      timestamp: new Date().toISOString(),
      uptime: process.uptime(),
      memory: process.memoryUsage(),
      environment: process.env.NODE_ENV || 'development',
    };
  }
}