import { IsNotEmpty, IsString, IsOptional, IsUUID } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class CreateMessageDto {
  @ApiProperty()
  @IsNotEmpty()
  @IsString()
  content: string;

  @ApiProperty({ default: 'text' })
  @IsOptional()
  @IsString()
  type?: string;

  @ApiProperty()
  @IsNotEmpty()
  @IsUUID()
  chatRoomId: string;

  @ApiProperty({ required: false })
  @IsOptional()
  @IsUUID()
  replyToId?: string;

  // This will be set by the service
  senderId?: string;
}