import {
  Entity,
  PrimaryGeneratedColumn,
  CreateDateColumn,
  ManyToOne,
} from 'typeorm';
import { Message } from './message.entity';
import { User } from './user.entity';

@Entity('message_mentions')
export class MessageMention {
  @PrimaryGeneratedColumn('uuid')
  id: string;

  @CreateDateColumn()
  createdAt: Date;

  @ManyToOne(() => Message, (message) => message.mentions)
  message: Message;

  @ManyToOne(() => User)
  mentionedUser: User;
}